<template>
  <div :class="{ 'post-list-item': true, 'post-list-item--op': isOp }" :id="`post${post.id}`">
    <div class="post-list-item__user">
      <div class="post-list-item__avatar">
        <router-link :to="userRoute">
          <UserAvatar :user="post.user" :size="size" />
        </router-link>
      </div>
      <div class="post-list-item__info">
        <div class="post-list-item__username">
          <router-link :to="userRoute">{{ username }}</router-link>
        </div>
        <div class="post-list-item__moderator" v-if="isModerator">
          <i class="bi bi-shield"></i>
          moderator
        </div>
        <div class="post-list-item__location">{{ location }}</div>
      </div>
    </div>
    <div class="post-list-item__body">
      <div class="post-list-item__bubble">
        <div class="post-list-item__header">
          <ul class="horizontal">
            <li>
              <router-link :to="postRoute">Post #{{ post.postNumber }}</router-link>
            </li>
            <li>
              <span data-bs-toggle="tooltip" :title="postCreatedTooltip">{{ postCreatedText }}</span>
            </li>
            <li v-if="post.editedByUserId" data-bs-toggle="tooltip" :title="editedByTooltip">Edited</li>
            <li v-if="canEditThisPost">
              <router-link :to="editPostRoute">Edit</router-link>
            </li>
          </ul>
        </div>
        <div class="post-list-item__content post-list-item__content--search-result" v-if="isSummary">
          <div class="post-list-item__cropped-text">
            <router-link :to="postRoute">&quot;<span v-html="summaryContent" />&quot;</router-link>
          </div>
          <ul class="responsive">
            <li>
              <router-link :to="topicRoute">{{ post.topic.title }}</router-link>
            </li>
            <li><router-link :to="postRoute">Read full post</router-link></li>
          </ul>
        </div>
        <div class="post-list-item__content" v-else>
          <span v-html="formattedContent" />
        </div>
        <div class="post-list-item__signature" v-if="showSignature">
          <span v-html="formattedSignature" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { UserAvatar } from '../../gallery'
import { usePostListitem } from './post-list-item.js'

export default {
  name: 'PostListItemListview',
  props: {
    post: { type: Object, required: true },
    alias: { type: String, default: '' },
    view: { type: String, default: 'list' }, // 'list', 'list-summary'
    opUserId: { type: Number, default: 0 },
  },
  components: {
    UserAvatar,
  },
  setup(props) {
    return usePostListitem(props)
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.post-list-item {
  margin: vars.$spacing * 3 0;
}

.post-list-item__user {
  display: flex;
  margin-bottom: vars.$spacing * 0.5;
  flex-shrink: 0;
}

.post-list-item__avatar {
  text-align: center;
  margin-right: vars.$spacing;
}

.post-list-item__avatar .user-avatar {
  width: vars.$avatarWidth;
  height: vars.$avatarWidth;
}

.post-list-item__info {
  flex-grow: 1;
  align-self: center;
}

.post-list-item__moderator i {
  color: gold;
}

.post-list-item__location {
  font-size: vars.$subtextFontSize;
}

.post-list-item__bubble {
  word-wrap: break-word;
  position: relative;
  padding: vars.$spacing;
  border-radius: 1rem;
  border-top-left-radius: 0.25rem;
  background-color: vars.$panelColor;
}

.dark .post-list-item__bubble {
  background-color: vars.$darkPanelColor;

  p:last-of-type {
    margin-bottom: 0;
  }
}

.post-list-item--op .post-list-item__bubble {
  background-color: tint(lightskyblue, 65%);
}

.dark .post-list-item--op .post-list-item__bubble {
  background-color: shade(lightskyblue, 85%);
}

.post-list-item__header {
  text-align: right;
  font-size: vars.$subtextFontSize;
  font-style: italic;
  color: vars.$subtextColor;
  margin-bottom: vars.$spacing * 0.5;

  a {
    color: vars.$subtextColor;
  }
}

.dark .post-list-item__header {
  color: vars.$darkSubtextColor;

  a {
    color: vars.$darkSubtextColor;
  }
}

.post-list-item__cropped-text {
  font-style: italic;
  margin-bottom: vars.$spacing;

  a {
    color: vars.$textColor;
  }
}

.dark .post-list-item__cropped-text a {
  color: vars.$darkTextColor;
}

.post-list-item__signature {
  margin-top: vars.$spacing;
  border-top: vars.$separatorColor 1px solid;
  padding-top: vars.$spacing;
  font-size: vars.$subtextFontSize;
  opacity: 0.75;
}

.dark .post-list-item__signature {
  border-top-color: vars.$darkSeparatorColor;
}

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .post-list-item {
    display: flex;
    margin: vars.$spacing * 2 0;
  }

  .post-list-item__user {
    display: block;
    margin-right: vars.$spacing;
    margin-bottom: 0;
    width: vars.$galleryThumbWidthLarge;
  }

  .post-list-item__avatar {
    flex: 0 0 auto;
    margin-right: 0;
  }

  .post-list-item__avatar .user-avatar {
    width: vars.$avatarWidthLarge;
    height: vars.$avatarWidthLarge;
  }

  .post-list-item__info {
    flex-grow: 0;
    align-self: stretch;
    text-align: center;
  }

  .post-list-item__body {
    flex-grow: 1;
  }
}
</style>
